"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from leonardo_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from leonardo_ai_sdk.utils import FieldMetadata, PathParamMetadata
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DeleteDatasetByIDRequestTypedDict(TypedDict):
    id: str
    r"""The ID of the dataset to delete."""


class DeleteDatasetByIDRequest(BaseModel):
    id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the dataset to delete."""


class DeleteDatasetByIDDatasetsTypedDict(TypedDict):
    r"""columns and relationships of \"datasets\" """

    id: NotRequired[Nullable[str]]


class DeleteDatasetByIDDatasets(BaseModel):
    r"""columns and relationships of \"datasets\" """

    id: OptionalNullable[str] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["id"]
        nullable_fields = ["id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class DeleteDatasetByIDResponseBodyTypedDict(TypedDict):
    r"""Responses for DELETE /datasets/{id}"""

    delete_datasets_by_pk: NotRequired[Nullable[DeleteDatasetByIDDatasetsTypedDict]]
    r"""columns and relationships of \"datasets\" """


class DeleteDatasetByIDResponseBody(BaseModel):
    r"""Responses for DELETE /datasets/{id}"""

    delete_datasets_by_pk: OptionalNullable[DeleteDatasetByIDDatasets] = UNSET
    r"""columns and relationships of \"datasets\" """

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["delete_datasets_by_pk"]
        nullable_fields = ["delete_datasets_by_pk"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class DeleteDatasetByIDResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    object: NotRequired[DeleteDatasetByIDResponseBodyTypedDict]
    r"""Responses for DELETE /datasets/{id}"""


class DeleteDatasetByIDResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    object: Optional[DeleteDatasetByIDResponseBody] = None
    r"""Responses for DELETE /datasets/{id}"""
