"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from leonardo_ai_sdk.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PromptImproveRequestBodyTypedDict(TypedDict):
    r"""Query parameters to be provided in the request body as a JSON object"""

    prompt: str
    r"""The prompt to improve."""


class PromptImproveRequestBody(BaseModel):
    r"""Query parameters to be provided in the request body as a JSON object"""

    prompt: str
    r"""The prompt to improve."""


class PromptGenerationOutputTypedDict(TypedDict):
    api_credit_cost: NotRequired[int]
    r"""API Credits Cost for Random Prompt Generation. Available for Production API Users."""
    prompt: NotRequired[str]
    r"""The improved prompt."""


class PromptGenerationOutput(BaseModel):
    api_credit_cost: Annotated[Optional[int], pydantic.Field(alias="apiCreditCost")] = 4
    r"""API Credits Cost for Random Prompt Generation. Available for Production API Users."""

    prompt: Optional[str] = "The improved prompt."
    r"""The improved prompt."""


class PromptImproveResponseBodyTypedDict(TypedDict):
    r"""Responses for POST /prompt/improve"""

    prompt_generation: NotRequired[PromptGenerationOutputTypedDict]


class PromptImproveResponseBody(BaseModel):
    r"""Responses for POST /prompt/improve"""

    prompt_generation: Annotated[
        Optional[PromptGenerationOutput], pydantic.Field(alias="promptGeneration")
    ] = None


class PromptImproveResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    object: NotRequired[PromptImproveResponseBodyTypedDict]
    r"""Responses for POST /prompt/improve"""


class PromptImproveResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    object: Optional[PromptImproveResponseBody] = None
    r"""Responses for POST /prompt/improve"""
